#include <iostream>
#include <fstream>
#include <string>
using namespace std;

struct Personne{
	string nom;
	string prenom;
	float age;
	string telephone;
	string mail;
};

//fonction pour crer une personne
//elle retourne donc une personne et ne prend pas de paramtre...
Personne initPersonne(){
	Personne newP;
	cout<<"----- Saisie d'une nouvelle personne -----"<<endl<<endl;
	cout<<"Quel est son nom ? ";
	cin>>newP.nom;
	cout<<"Quel est son prenom ? ";
	cin>>newP.prenom;
	cout<<"Quel est son age ? ";
	cin>>newP.age;
	cout<<"Quel est son telephone ? ";
	cin>>newP.telephone;
	cout<<"Quel est son email ? ";
	cin>>newP.mail;
	return newP;
}

//fonction pour afficher une personne
//elle ne retourne rien mais prend une personne en paramtre
void affichePersonne(Personne pers){
	cout<<"----- "<<pers.nom<<" "<<pers.prenom<<" -----"<<endl<<endl;
	cout<<"Age : "<<pers.age<<endl;
	cout<<"Telephone : "<<pers.telephone<<endl;
	cout<<"Email : "<<pers.mail<<endl<<endl;
}

//fonction qui permet d'enregistrer tout le tableau de personnes
//la fonction a donc besoin de la liste de personne (le tableau)
//ainsi que du nombre de personnes :
void enregistrePersonnes(Personne liste[100],int nbP){
	ofstream fichier("listePersonne.txt");
	//on enregistre tout d'abord le nombre de personnes qu'il y a :
	//a permettra de savoir tout de suite combien de personnes il y a :
	fichier<<nbP<<endl;
	//ensuite, on utilise une boucle qui enregistre toutes les personnes :
	for(int i=0;i<nbP;i++){
		fichier<<liste[i].nom<<endl;
		fichier<<liste[i].prenom<<endl;
		fichier<<liste[i].age<<endl;
		fichier<<liste[i].telephone<<endl;
		fichier<<liste[i].mail<<endl;
	}
	//puis on referme le fichier :
	fichier.close();
	cout<<"les personnes ont bien etes enregistres..."<<endl;
	system("pause");
}

//fonction qui permet de charger toute une liste de personnes  partir d'un fichier
//la fonction a donc besoin de la liste de personne (le tableau)
//ainsi que du nombre de personnes (que l'on va modifier, penser au &):
void chargePersonnes(Personne liste[100],int &nbP){
	ifstream fichier("listePersonne.txt");
	//on lit tout d'abord le nombre de personnes qu'il y a dans le fichier :
	int nbPersFichier;
	fichier>>nbPersFichier;
	//ensuite, on utilise une boucle pour ajouter toutes les personnes :
	for(int i=nbP;i<nbP+nbPersFichier;i++){
		fichier>>liste[i].nom;
		fichier>>liste[i].prenom;
		fichier>>liste[i].age;
		fichier>>liste[i].telephone;
		fichier>>liste[i].mail;
	}
	//puis on referme le fichier :
	fichier.close();
	cout<<"les personnes ont bien etes chargees..."<<endl;
	//puisqu'on a ajout des personnes, il faut mettre  jour le nombre de personnes
	nbP=nbP+nbPersFichier;
	system("pause");
}

//fonction qui recherche une personne dans la liste :
void cherchePersonnes(Personne liste[100],int nbP,string nom){
	int nbPersonnesTrouvee=0;
	for(int i=0;i<nbP;i++){
		if(liste[i].nom==nom){
			affichePersonne(liste[i]);
			nbPersonnesTrouvee++;
		}
	}
	if(nbPersonnesTrouvee==0){
		cout<<"aucune personne n'a ce nom..."<<endl;
	}
	system("pause");
}

//fonction qui affiche un menu pour permettre de choisir ce qu'on veux faire
//retourne le choix de l'utilisateur :
int afficheMenu(){
	system("cls");//efface l'cran
	int choix=-1;//initialis  -1 pour rentrer dans la boucle
	//cette boucle permet d'tre sur que le choix est compris entre 0 et 4
	while((choix<0)||(choix>5)){
		cout<<"------ MENU ------"<<endl<<endl;
		cout<<"0 -> quitter"<<endl;
		cout<<"1 -> ajouter une personne"<<endl;
		cout<<"2 -> afficher les personnes"<<endl;
		cout<<"3 -> charger une liste de personnes"<<endl;
		cout<<"4 -> enregistrer une liste de personnes"<<endl;
		cout<<"5 -> chercher une personne"<<endl;
		cin>>choix;
	}
	return choix;
}

void main(){
	//le tableau de personnes
	Personne listePersonnes[100];
	//le nombre de personnes qu'il y a dans le tableau
	int nbPersonnes=0;
	//le choix de l'utilisateur pour le menu
	int queFaire=-1;
	//tant qu'on ne fait pas le choix 0 (voir l'affichage du menu)
	while(queFaire!=0){
		queFaire=afficheMenu();
		switch(queFaire){
			case 1:
		//enregistre une nouvelle personne dans le tableau :
				listePersonnes[nbPersonnes]=initPersonne();
				nbPersonnes++;
				break;
			case 2:
				system("cls");//efface l'cran
				for(int i=0;i<nbPersonnes;i++){
					affichePersonne(listePersonnes[i]);
				}
				system("pause");
				break;
			case 3:
				//on utilise la fonction qui permet de charger les personnes :
				chargePersonnes(listePersonnes,nbPersonnes);
				break;
			case 4:
				//on utilise la fonction qui permet d'enregistrer les personnes :
				enregistrePersonnes(listePersonnes,nbPersonnes);
				break;
			case 5:
				string nomPersonne;
				cout<<"veuillez saisir le nom d'une personne (attention aux majuscules) : ";
				cin>>nomPersonne;
				//on utilise la fonction qui permet d'enregistrer les personnes :
				cherchePersonnes(listePersonnes,nbPersonnes,nomPersonne);
				break;
		};
	};
	cout<<"fin du programme"<<endl;
}